[FSUTMS Transit Path Building & Skimming (Tier A)]
;;<<Process Template>><<PUBLIC TRANSPORT>>;;
;{note1,note,18,"FSUTMS Transit Path Building & Skimming (Tier A)"}
;Input Highway Network: {neti,filename,"Input Highway Network",x,"","Highway Network (*.net)|*.net"}
;Input Transit Route File: {linei,filename,"Input Transit Route File",x,"","Transit Route File (*.lin)|*.lin"}
;Input Transit System Data File: {systemi,filename,"Input Transit System Data File",x,"","Transit System Data File (*.pts)|*.pts"}
;Input Transit Fare System File: {farei,filename,"Input Transit Fare System File",x,"","Transit Fare System File (*.far)|*.far"}
;Input User Class 1 Factors File: {factori1,filename,"Input User Class 1 Factors File",x,"","Factors File (*.fac)|*.fac"}
;Input User Class 2 Factors File: {factori2,filename,"Input User Class 2 Factors File",x,"","Factors File (*.fac)|*.fac"}
;Input Non-Transit Leg File 1: {ntlegi1,filename,"Input Non-Transit Leg File 1",x,"","Non-Transit Leg File (*.ntl)|*.ntl"}
;Input Non-Transit Leg File 2: {ntlegi2,filename,"Input Non-Transit Leg File 2",x,"","Non-Transit Leg File (*.ntl)|*.ntl"}
;Input Non-Transit Leg File 3: {ntlegi3,filename,"Input Non-Transit Leg File 3",x,"","Non-Transit Leg File (*.ntl)|*.ntl"}
;Input Non-Transit Leg File 4: {ntlegi4,filename,"Input Non-Transit Leg File 4",x,"","Non-Transit Leg File (*.ntl)|*.ntl"}
;Output Network: {neto,filename,"Output Network",x,"","Network (*.net)|*.net"}
;Output Report File: {reporto,filename,"Output Report File",x,"","Report File (*.prn)|*.prn"}
;Output Print File: {prno,filename,"Output Print File",x,"","Print File (*.prn)|*.prn"}
;Output User Class 1 Route File: {routeo1,filename,"Output User Class 1 Route File",x,"","Route File (*.rte)|*.rte"}
;Output User Class 2 Route File: {routeo2,filename,"Output User Class 2 Route File",x,"","Route File (*.rte)|*.rte"}
;Output User Class 1 Skim File: {mato1,filename,"Output User Class 1 Skim File",x,"","Matrix File (*.mat)|*.mat"}
;Output User Class 2 Skim File: {mato2,filename,"Output User Class 2 Skim File",x,"","Matrix File (*.mat)|*.mat"}
;HeadwayPeriod: {hdp,editbox,"Headway Period",N,""}
;Selected Origin Zones for Reporting: {selo,editbox,"Selected Origin Zones",T,""}
;Selected Destination Zones for Reporting: {seld,editbox,"Selected Destination Zones",T,""}
;;<<End Parameters>>;;
RUN PGM=PUBLIC TRANSPORT PRNFILE={prno.q} MSG='Transit paths and skims'
; Output files
FILEO MATO[2] = {mato2.q},
 MO=1-15,DEC=15*S, NAME=WALKTIME,AutoTIME,XferTIME,BUSTIME,PBUSTIME,CIRCTIME,HRAILTIME,COMRLTIME,OTHRTIME,PRJTIME,XFER,IWAIT,XWAIT,FARE,TOTALTIME
FILEO MATO[1] = {mato1.q},
 MO=1-15,DEC=15*S, NAME=WALKTIME,AutoTIME,XferTIME,BUSTIME,PBUSTIME,CIRCTIME,HRAILTIME,COMRLTIME,OTHRTIME,PRJTIME,XFER,IWAIT,XWAIT,FARE,TOTALTIME
FILEO ROUTEO[2] = {routeo2.q},
  REPORTI={selo.q}, REPORTJ={seld.q} ;,I={selo.q},J={seld.q}
FILEO ROUTEO[1] = {routeo1.q},
  REPORTI={selo.q}, REPORTJ={seld.q} ;,I={selo.q},J={seld.q}
FILEO REPORTO = {reporto.q},
FILEO NETO = {neto.q},
; Input files
FILEI NTLEGI[4] = {ntlegi4.q}
FILEI NTLEGI[3] = {ntlegi3.q}
FILEI NTLEGI[2] = {ntlegi2.q}
FILEI NTLEGI[1] = {ntlegi1.q}
FILEI FAREI = {farei.q}
FILEI SYSTEMI = {systemi.q}
FILEI LINEI[1] = {linei.q}
FILEI FACTORI[2] = {factori2.q}
FILEI FACTORI[1] = {factori1.q}
FILEI NETI = {neti.q}

; OVERALL PARAMETERS OF RUN
PARAMETERS USERCLASSES=1-2,FARE=N, MAPSCALE=5280, HDWAYPERIOD={hdp.q},
           NOROUTEERRS=999999, NOROUTEMSGS=999999,
           TRANTIME=LW.TRANTIME,
           TRANTIME[21]=LI.M21TIMEPK,
           TRANTIME[22]=LI.M22TIMEPK,
           TRANTIME[23]=LI.M23TIMEPK,
           TRANTIME[27]=LI.M27TIMEPK

REPORT LINES=T
REREPORT LINES=T,TRNLEGS3=T
PROCESS PHASE=LINKREAD
 LW.TRANTIME=LI.M21TIMEPK
 LW.WALKTIME=LI.WALKTIME
 LW.WALKDISTANCE=LI.DISTANCE
 LW.DISTANCE=LI.DISTANCE
ENDPROCESS

PROCESS PHASE=DATAPREP
    ; Generate walk-access links
     GENERATE READNTLEGI=1
    ; Generate PNR-access links
     GENERATE READNTLEGI=2
    ; Generate fixed-guideway to bus links
     GENERATE READNTLEGI=3
    ; Generate CBD transfer links
     GENERATE READNTLEGI=4
ENDPROCESS

PROCESS PHASE=SKIMIJ

 IF (USERCLASS==1 || USERCLASS==2)
  IF ((TIMEA(0,21)+TIMEA(0,23)) > 0)
   MW[1]=TIMEA(0,1)                                        ; Walk time
   MW[2]=TIMEA(0,2)                                        ; PNR time
   MW[3]=TIMEA(0,11)+TIMEA(0,12)                           ; Transfer time
   MW[4]=TIMEA(0,21)                                       ; Local and express bus time
   MW[5]=TIMEA(0,22)                                       ; Premium bus time
   MW[6]=TIMEA(0,23)                                       ; Circulator bus time
   MW[7]=TIMEA(0,24)                                       ; Light, Heavy Rail time
   MW[8]=TIMEA(0,25)                                       ; Commuter Rail time
   MW[9]=TIMEA(0,26)                                       ; Other mode time
   MW[10]=TIMEA(0,27)                                      ; Project mode time
   IF (BRDINGS(0,TMODES) > 0)
    MW[11]=BRDINGS(0,TMODES)-1                              ; Number of transfers
   ELSE
    MW[11]=0
   ENDIF
   MW[12]=IWAITA(0)                                        ; Initial wait time
   MW[13]=XWAITA(0)                                        ; Transfer wait time
   MW[14]=FAREA(0)*100                                     ; Fare matrix
   MW[15]=TIMEA(0,ALLMODES)                                ; Time on all modes
  ELSE
   MW[1]=0
   MW[2]=0
   MW[3]=0
   MW[4]=0
   MW[5]=0
   MW[6]=0
   MW[7]=0
   MW[8]=0
   MW[9]=0
   MW[10]=0
   MW[11]=0
   MW[12]=0
   MW[13]=0
   MW[14]=0
   MW[15]=0
  ENDIF

 ELSEIF (USERCLASS==2)
  IF ((TIMEA(0,22)+TIMEA(0,27)) > 0)
   MW[1]=TIMEA(0,1)                                        ; Walk time
   MW[2]=TIMEA(0,2)                                        ; PNR time
   MW[3]=TIMEA(0,11)+TIMEA(0,12)                           ; Transfer time
   MW[4]=TIMEA(0,21)                                       ; Local and express bus time
   MW[5]=TIMEA(0,22)                                       ; Premium bus time
   MW[6]=TIMEA(0,23)                                       ; Circulator bus time
   MW[7]=TIMEA(0,24)                                       ; Light, Heavy Rail time
   MW[8]=TIMEA(0,25)                                       ; Commuter Rail time
   MW[9]=TIMEA(0,26)                                       ; Other mode time
   MW[10]=TIMEA(0,27)                                      ; Project mode time
   IF (BRDINGS(0,TMODES) > 0)
    MW[11]=BRDINGS(0,TMODES)-1                              ; Number of transfers
   ELSE
    MW[11]=0
   ENDIF
   MW[12]=IWAITA(0)                                        ; Initial wait time
   MW[13]=XWAITA(0)                                        ; Transfer wait time
   MW[14]=FAREA(0)*100                                     ; Fare matrix
   MW[15]=TIMEA(0,ALLMODES)                                ; Time on all modes
  ELSE
   MW[1]=0
   MW[2]=0
   MW[3]=0
   MW[4]=0
   MW[5]=0
   MW[6]=0
   MW[7]=0
   MW[8]=0
   MW[9]=0
   MW[10]=0
   MW[11]=0
   MW[12]=0
   MW[13]=0
   MW[14]=0
   MW[15]=0
  ENDIF

 ENDIF

ENDPROCESS

ENDRUN
